<form [formGroup]="network" (ngSubmit)="submit()" novalidate>
  <mat-stepper [orientation]="(stepperOrientation | async)!">
    <mat-step label="General Information">
      <div class="general">
        <div></div> <!-- Platzhalter -->
        <div>
          <h2>Address</h2>
          <div class="blackLine"></div>
        </div>
        <div>
          <h2>Logo</h2>
          <div class="blackLine"></div>
        </div>

        <div>
          <mat-form-field class="name">
            <mat-label>Name of Network</mat-label>
            <input matInput formControlName="name">
            <mat-error *ngIf="network.get('name')!.value.length != 0">Max length is {{Global.textFormFieldsLength}}
              characters.</mat-error>
          </mat-form-field>
          <mat-form-field class="shortcut">
            <mat-label>Shortcut</mat-label>
            <input matInput formControlName="shortcut">
            <mat-error *ngIf="network.get('shortcut')!.value.length != 0">Max length is {{Global.textFormFieldsLength}}
              characters.</mat-error>
          </mat-form-field>
          <mat-form-field class="externalLink">
            <mat-label>External Link</mat-label>
            <input matInput formControlName="external_link">
            <mat-error *ngIf="network.get('external_link')?.value !== null && network.get('external_link')!.value.length !== 0">
              Max length is {{Global.textFormFieldsLength}} characters.
            </mat-error>
          </mat-form-field>
        </div>

        <div>
          <mat-form-field class="street">
            <mat-label>Street and house number</mat-label>
            <input matInput formControlName="street">
            <mat-error *ngIf="network.get('street')!.value.length != 0">Max length is {{Global.textFormFieldsLength}}
              characters.</mat-error>
          </mat-form-field>
          <mat-form-field class="zip">
            <mat-label>ZIP</mat-label>
            <input matInput formControlName="zip">
            <mat-error *ngIf="network.get('zip')!.value.length != 0">Max length is {{Global.textFormFieldsLength}}
              characters.</mat-error>
          </mat-form-field>
          <mat-form-field class="city">
            <mat-label>City</mat-label>
            <input matInput formControlName="city">
            <mat-error *ngIf="network.get('city')!.value.length != 0">Max length is {{Global.textFormFieldsLength}}
              characters.</mat-error>
          </mat-form-field>
          <mat-form-field class="country">
            <mat-label>Country</mat-label>
            <input matInput formControlName="country">
            <mat-error *ngIf="network.get('country')!.value.length != 0">Max length is {{Global.textFormFieldsLength}}
              characters.</mat-error>
          </mat-form-field>
        </div>

        <div>
          <app-upload-box
            matInput
            [allowedTypes]="['png', 'jpeg', 'jpg', 'webp', 'svg']"
            [description]="'Network Logo'"
            [fileClass]="'logos'"
            [form]="network"
            [controlName]="'logo'"
            [defaultFile]="this.network.get('logo')!.value"
            (uploadStarted)="blockFormSubmit('logo')"
            (uploadFinished)="unblockFormSubmit('logo')"
            (fileNameReturn)="updateLogo($event.filename)"
            class="fileDropper"
          />
        </div>

        <div class="navigation">
          <button mat-icon-button matStepperPrevious color="primary" aria-label="back">
            <mat-icon>keyboard_arrow_left</mat-icon>
          </button>
          <button mat-icon-button matStepperNext color="primary" aria-label="forward">
            <mat-icon>keyboard_arrow_right</mat-icon>
          </button>
        </div>
      </div>
    </mat-step>
    <mat-step label="Describe your Network">
      <div class="description">
        <mat-form-field>
          <mat-label>General Description</mat-label>
          <textarea matInput formControlName="description" rows="7"></textarea>
          <mat-error *ngIf="network.get('name')!.value.length != 0">Max length is {{Global.textAreaFormFieldsLength}}
            characters.</mat-error>
        </mat-form-field>
        <mat-form-field>
          <mat-label>Research Description</mat-label>
          <textarea matInput formControlName="research_description" rows="7"></textarea>
          <mat-error *ngIf="network.get('name')!.value.length != 0">Max length is {{Global.textAreaFormFieldsLength}}
            characters.</mat-error>
        </mat-form-field>

        <div class="navigation">
          <button mat-icon-button matStepperPrevious color="primary" aria-label="back">
            <mat-icon>keyboard_arrow_left</mat-icon>
          </button>
          <button mat-icon-button matStepperNext color="primary" aria-label="forward">
            <mat-icon>keyboard_arrow_right</mat-icon>
          </button>
        </div>
      </div>
    </mat-step>
    <mat-step label="Add existing profiles">
      <mat-form-field>
        <mat-select placeholder="Profiles" formControlName="profiles" [(value)]="selectedProfiles" multiple>
          <mat-option *ngFor="let profile of profileList" [value]="profile.id">{{profile.title}}</mat-option>
        </mat-select>
      </mat-form-field>

      <div class="navigation">
        <button mat-icon-button matStepperPrevious color="primary" aria-label="back">
          <mat-icon>keyboard_arrow_left</mat-icon>
        </button>
        <div matTooltip="Check if all required forms are filled out." [matTooltipDisabled]="network.valid">
          <button mat-fab extended color="primary" aria-label="save" [disabled]="!network.valid" type="submit">
            <mat-icon>send</mat-icon>
            <span *ngIf="id">Update network</span>
            <span *ngIf="!id">Create network</span>
          </button>
        </div>
        <mat-spinner #spinner [ngStyle]="{'display': spinnerVisible ? 'block' : 'none'}"
          style="width: 40px; margin-left: 20px;"></mat-spinner>
      </div>
    </mat-step>
  </mat-stepper>
</form>
